﻿
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace VZInterfaceTestHandbook
{
  public partial class FormDevices : Form
  {
    IComIf comIf;
    public FormDevices(IComIf com)
    {
      comIf = com;
      InitializeComponent();
    }

    private void buttonReturn_Click(object sender, EventArgs e)
    {
      Close();
    }

    private void buttonScan_Click(object sender, EventArgs e)
    {
      // clear the listview for rewrite
      listViewDevice.Items.Clear();

      // initialize the scan of the the devices
      Devices devices = new Devices(comIf);
      string[] device = devices.ScanDevices();

      for (int i = 0; i < device.Length; i++)
      {
        string[] listEntry = new string[4];

        // split a string into a string array
        listEntry = device[i].Split('&');

        // split the string array into parts
        // to order it new
        string serialNumber = listEntry[0];
        string version = listEntry[1];
        string model = listEntry[2];

        // classify the partition to wished order
        listEntry[0] = model;
        listEntry[1] = version;
        listEntry[2] = serialNumber;

        // add item into listview
        listViewDevice.Items.Add(new ListViewItem(listEntry));
      }
    }
  }
}
