﻿
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace VZInterfaceTestHandbook
{
  /**
   * GET/SET Power example
   */
  public partial class FormPowerSettings : Form
  {
    //@@@START_FORMPOWERSETTINGS@@@
    IComIf comIf;
    Boolean isConnected = false;

    /**
     * constructor
     * @param com: uses Interface IComIf
     */
    public FormPowerSettings(IComIf com)
    {
      comIf = com;
      InitializeComponent();
    }
    //@@@STOP_FORMPOWERSETTINGS@@@

    /**
     * Open connection
     * @return success = false
     */
    private Boolean connOpen()
    {
      if (comIf.Open())
      {
        MessageBox.Show("Couldn´t open interface!", "Error",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Error);
        return true;
      }
      isConnected = true;
      return false;
    }

    /**
     * Close connection
     */
    private void connClose()
    {
      if (isConnected)
        comIf.Close();
      isConnected = false;
    }

    //@@@START_BUTTONPOWERON@@@
    private void buttonPowerOn_Click(object sender, EventArgs e)
    {
      /*Instantiate class*/
      PowerSettings pS = new PowerSettings(comIf);
      /*Open interface*/
      if (connOpen())
        return;
      /*Send command*/
      pS.PowerON();
      /*Close interface*/
      connClose();
    }
    //@@@STOP_BUTTONPOWERON@@@

    private void buttonPowerOff_Click(object sender, EventArgs e)
    {
      PowerSettings pS = new PowerSettings(comIf);
      if (connOpen())
        return;
      pS.PowerOff();
      connClose();
    }

    //@@@START_BUTTONGETPOWERSTATE@@@
    private void buttonGetPowerState_Click(object sender, EventArgs e)
    {
      /*Instantiate class*/
      PowerSettings pS = new PowerSettings(comIf);
      /*Open interface*/
      if (connOpen())
        return;
      /*Send command*/
      pS.GetPowerState();
      /*Close interface*/
      connClose();
    }
    //@@@STOP_BUTTONGETPOWERSTATE@@@

    /**
     * Close the form
     */
    private void buttonReturn_Click(object sender, EventArgs e)
    {
      connClose();
      Close();
    }
  }
}
