﻿
using System;
using System.Windows.Forms;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace VZInterfaceTestHandbook
{
  /**
   * Height Adjustment commands
   */
  class Heightadjustment
  {
    IComIf comIf;
    /**
     * @param com: uses Interface IComIf
     */
    public Heightadjustment(IComIf com)
    {
      comIf = com;
    }

    public Boolean StartAutoAdjustment()
    {
      Wolfprot2 wp2 = new Wolfprot2(comIf);
      Byte[] bufSnd = new Byte[4];
      Byte[] bufRecv = new Byte[3];
      Boolean iReturn;

      bufSnd[0] = 0x01;
      bufSnd[1] = 0x2D;
      bufSnd[2] = 0x01;
      bufSnd[3] = 0x03;

      iReturn = wp2.execCmd(bufSnd, ref bufRecv);
      if (iReturn == true)
      {
        MessageBox.Show("No communication!", "Error",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Error);
        return true;
      }
      else
      {
        if ((bufRecv[0] & 0x80) == 0x80)
        {
          wp2.ErrorSummary(bufRecv[2]);
          return true;
        }
        else
        {
          return false;
        }
      }
    }

    public Boolean StartManualAdjustment()
    {
      Wolfprot2 wp2 = new Wolfprot2(comIf);
      Byte[] bufSnd = new Byte[4];
      Byte[] bufRecv = new Byte[3];
      Boolean iReturn;

      bufSnd[0] = 0x01;
      bufSnd[1] = 0x2D;
      bufSnd[2] = 0x01;
      bufSnd[3] = 0x04;

      iReturn = wp2.execCmd(bufSnd, ref bufRecv);
      if (iReturn == true)
      {
        MessageBox.Show("No communication!", "Error",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Error);
        return true;
      }
      else
      {
        if ((bufRecv[0] & 0x80) == 0x80)
        {
          wp2.ErrorSummary(bufRecv[2]);
          return true;
        }
        else
          return false;
      }
    }

    public Boolean Cancel()
    {
      Wolfprot2 wp2 = new Wolfprot2(comIf);
      Byte[] bufSnd = new Byte[4];
      Byte[] bufRecv = new Byte[3];
      Boolean iReturn;

      bufSnd[0] = 0x01;
      bufSnd[1] = 0x2D;
      bufSnd[2] = 0x01;
      bufSnd[3] = 0x05;

      iReturn = wp2.execCmd(bufSnd, ref bufRecv);
      if (iReturn == true)
      {
        MessageBox.Show("No communication!", "Error",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Error);
        return true;
      }
      else
      {
        if ((bufRecv[0] & 0x80) == 0x80)
        {
          wp2.ErrorSummary(bufRecv[2]);
          return true;
        }
        else
        {
          return false;
        }
      }
    }

    public Boolean Accept()
    {
      Wolfprot2 wp2 = new Wolfprot2(comIf);
      Byte[] bufSnd = new Byte[4];
      Byte[] bufRecv = new Byte[3];
      Boolean iReturn;

      bufSnd[0] = 0x01;
      bufSnd[1] = 0x2D;
      bufSnd[2] = 0x01;
      bufSnd[3] = 0x06;

      iReturn = wp2.execCmd(bufSnd, ref bufRecv);
      if (iReturn == true)
      {
        MessageBox.Show("No communication!", "Error",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Error);
        return true;
      }
      else
      {
        if ((bufRecv[0] & 0x80) == 0x80)
        {
          wp2.ErrorSummary(bufRecv[2]);
          return true;
        }
        else
        {
          return false;
        }
      }
    }

    #region Light Mirror Control

    public Boolean MirrorUp(Byte speed)
    {
      Wolfprot2 wp2 = new Wolfprot2(comIf);
      Byte[] bufSnd = new Byte[5];
      Byte[] bufRecv = new Byte[3];
      Boolean iReturn;

      bufSnd[0] = 0x01;
      bufSnd[1] = 0x25;
      bufSnd[2] = 0x02;
      bufSnd[3] = 0x02;
      bufSnd[4] = speed;

      iReturn = wp2.execCmd(bufSnd, ref bufRecv);
      if (iReturn == true)
      {
        MessageBox.Show("No communication!", "Error",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Error);
        return true;
      }
      else
      {
        if ((bufRecv[0] & 0x80) == 0x80)
        {
          wp2.ErrorSummary(bufRecv[2]);
          return true;
        }
        else
        {
          return false;
        }
      }
    }

    public Boolean MirrorLeft(Byte speed)
    {
      Wolfprot2 wp2 = new Wolfprot2(comIf);
      Byte[] bufSnd = new Byte[5];
      Byte[] bufRecv = new Byte[3];
      Boolean iReturn;

      bufSnd[0] = 0x01;
      bufSnd[1] = 0x25;
      bufSnd[2] = 0x02;
      bufSnd[3] = 0x04;
      bufSnd[4] = speed;

      iReturn = wp2.execCmd(bufSnd, ref bufRecv);
      if (iReturn == true)
      {
        MessageBox.Show("No communication!", "Error",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Error);
        return true;
      }
      else
      {
        if ((bufRecv[0] & 0x80) == 0x80)
        {
          wp2.ErrorSummary(bufRecv[2]);
          return true;
        }
        else
        {
          return false;
        }
      }
    }

    public Boolean MirrorRight(Byte speed)
    {
      Wolfprot2 wp2 = new Wolfprot2(comIf);
      Byte[] bufSnd = new Byte[5];
      Byte[] bufRecv = new Byte[3];
      Boolean iReturn;

      bufSnd[0] = 0x01;
      bufSnd[1] = 0x25;
      bufSnd[2] = 0x02;
      bufSnd[3] = 0x06;
      bufSnd[4] = speed;

      iReturn = wp2.execCmd(bufSnd, ref bufRecv);
      if (iReturn == true)
      {
        MessageBox.Show("No communication!", "Error",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Error);
        return true;
      }
      else
      {
        if ((bufRecv[0] & 0x80) == 0x80)
        {
          wp2.ErrorSummary(bufRecv[2]);
          return true;
        }
        else
        {
          return false;
        }
      }
    }

    public Boolean MirrorDown(Byte speed)
    {
      Wolfprot2 wp2 = new Wolfprot2(comIf);
      Byte[] bufSnd = new Byte[5];
      Byte[] bufRecv = new Byte[3];
      Boolean iReturn;

      bufSnd[0] = 0x01;
      bufSnd[1] = 0x25;
      bufSnd[2] = 0x02;
      bufSnd[3] = 0x08;
      bufSnd[4] = speed;

      iReturn = wp2.execCmd(bufSnd, ref bufRecv);
      if (iReturn == true)
      {
        MessageBox.Show("No communication!", "Error",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Error);
        return true;
      }
      else
      {
        if ((bufRecv[0] & 0x80) == 0x80)
        {
          wp2.ErrorSummary(bufRecv[2]);
          return true;
        }
        else
        {
          return false;
        }
      }
    }

    #endregion

    #region Focus Control

    public Boolean LightFocusFar(Byte speed)
    {
      Wolfprot2 wp2 = new Wolfprot2(comIf);
      Byte[] bufSnd = new Byte[5];
      Byte[] bufRecv = new Byte[3];
      Boolean iReturn;

      bufSnd[0] = 0x01;
      bufSnd[1] = 0x26;
      bufSnd[2] = 0x02;
      bufSnd[3] = 0x02;
      bufSnd[4] = speed;

      iReturn = wp2.execCmd(bufSnd, ref bufRecv);
      if (iReturn == true)
      {
        MessageBox.Show("No communication!", "Error",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Error);
        return true;
      }
      else
      {
        if ((bufRecv[0] & 0x80) == 0x80)
        {
          wp2.ErrorSummary(bufRecv[2]);
          return true;
        }
        else
        {
          return false;
        }
      }
    }

    public Boolean LightFocusNear(Byte speed)
    {
      Wolfprot2 wp2 = new Wolfprot2(comIf);
      Byte[] bufSnd = new Byte[5];
      Byte[] bufRecv = new Byte[3];
      Boolean iReturn;

      bufSnd[0] = 0x01;
      bufSnd[1] = 0x26;
      bufSnd[2] = 0x02;
      bufSnd[3] = 0x01;
      bufSnd[4] = speed;

      iReturn = wp2.execCmd(bufSnd, ref bufRecv);
      if (iReturn == true)
      {
        MessageBox.Show("No communication!", "Error",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Error);
        return true;
      }
      else
      {
        if ((bufRecv[0] & 0x80) == 0x80)
        {
          wp2.ErrorSummary(bufRecv[2]);
          return true;
        }
        else
        {
          return false;
        }
      }
    }

    public Boolean CameraFocusFar(Byte speed)
    {
      Wolfprot2 wp2 = new Wolfprot2(comIf);
      Byte[] bufSnd = new Byte[6];
      Byte[] bufRecv = new Byte[3];
      Boolean iReturn;

      bufSnd[0] = 0x01;
      bufSnd[1] = 0x21;
      bufSnd[2] = 0x03;
      bufSnd[3] = 0x01;
      bufSnd[4] = 0x00;
      bufSnd[5] = speed;

      iReturn = wp2.execCmd(bufSnd, ref bufRecv);
      if (iReturn == true)
      {
        MessageBox.Show("No communication!", "Error",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Error);
        return true;
      }
      else
      {
        if ((bufRecv[0] & 0x80) == 0x80)
        {
          wp2.ErrorSummary(bufRecv[2]);
          return true;
        }
        else
        {
          return false;
        }
      }
    }

    public Boolean CameraFocusNear(Byte speed)
    {
      Wolfprot2 wp2 = new Wolfprot2(comIf);
      Byte[] bufSnd = new Byte[6];
      Byte[] bufRecv = new Byte[3];
      Boolean iReturn;

      bufSnd[0] = 0x01;
      bufSnd[1] = 0x21;
      bufSnd[2] = 0x03;
      bufSnd[3] = 0x02;
      bufSnd[4] = 0x00;
      bufSnd[5] = speed;

      iReturn = wp2.execCmd(bufSnd, ref bufRecv);
      if (iReturn == true)
      {
        MessageBox.Show("No communication!", "Error",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Error);
        return true;
      }
      else
      {
        if ((bufRecv[0] & 0x80) == 0x80)
        {
          wp2.ErrorSummary(bufRecv[2]);
          return true;
        }
        else
        {
          return false;
        }
      }
    }

    #endregion

    #region Get commands
    public string GetHeightAdjustmentState()
    {
      Wolfprot2 wp2 = new Wolfprot2(comIf);
      Byte[] bufSnd = new Byte[3];
      Byte[] bufRecv = new Byte[4];
      string state = "";
      Boolean iReturn;

      bufSnd[0] = 0x00;
      bufSnd[1] = 0x2D;
      bufSnd[2] = 0x00;

      iReturn = wp2.execCmd(bufSnd, ref bufRecv);
      if (iReturn == true)
      {
        MessageBox.Show("No communication!", "Error",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Error);
      }
      else
      {
        if ((bufRecv[0] & 0x80) == 0x80)
        {
          wp2.ErrorSummary(bufRecv[2]);
        }
        else
        {
          state = State(bufRecv[3]);
        }
      }
      return state;
    }

    public int GetTimeLeft()
    {
      Wolfprot2 wp2 = new Wolfprot2(comIf);
      Byte[] bufSnd = new Byte[3];
      Byte[] bufRecv = new Byte[4];
      Boolean iReturn;
      int time;

      bufSnd[0] = 0x00;
      bufSnd[1] = 0x2E;
      bufSnd[2] = 0x00;

      iReturn = wp2.execCmd(bufSnd, ref bufRecv);
      if (iReturn == true)
      {
        MessageBox.Show("No communication!", "Error",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Error);
        time = -1;
      }
      else
      {
        if ((bufRecv[0] & 0x80) == 0x80)
        {
          wp2.ErrorSummary(bufRecv[2]);
          time = -1;
        }
        else
        {
          time = (int)(bufRecv[3] & 0x000000FF);
        }
      }
      return time;
    }

    /**
    * Convert the reply packet into a string
    */
    public string State(Byte recv)
    {
      string state = "";

      if (recv == 0x00)
        state = "Stop";
      else if (recv == 0x01)
        state = "Running";
      else if (recv == 0x02)
        state = "Center Light Field";
      else if (recv == 0x03)
        state = "Adjust Camera Focus";
      else if (recv == 0x04)
        state = "Adjust Light Focus";
      else if (recv == 0x05)
        state = "Done";

      return state;
    }
    #endregion
  }
}
