﻿
using System;
using System.IO;
using System.Windows;
using System.Windows.Forms;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using System.Xml;

namespace VZInterfaceTestHandbook
{
  class XMLFile
  {
    IComIf comIf;
    /**
     * @param com: uses Interface IComIf
     */
    public XMLFile(IComIf com)
    {
      comIf = com;
    }

    //@@@START_READXMLFILE@@@
    public Boolean readXMLFile(string path)
    {
      Wolfprot2 wp2 = new Wolfprot2(comIf);
      Byte[] bufSnd = new Byte[3];
      Byte[] bufRecv = new Byte[10000000]; //10MB
      Boolean iReturn;

      bufSnd[0] = 0x00;
      bufSnd[1] = 0xCA;
      bufSnd[2] = 0x00;

      iReturn = wp2.execCmd(bufSnd, ref bufRecv);
      if (iReturn == true)
      {
        MessageBox.Show("No communication!", "Error",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Error);
        return true;
      }
      else
      {
        if ((bufRecv[0] & 0x80) == 0x80)
        {
          wp2.ErrorSummary(bufRecv[2]);
          return true;
        }
        else
        {
          // Read the Bytes for the length of the XML file
          // from bufRecv
          Byte[] bytelength = new Byte[4];

          for (int i = 0; i < bytelength.Length; i++)
          {
            bytelength[i] = bufRecv[i + 3];
          }

          // Convert the byte array to a integer
          uint XMLFilelength = Convert.ToUInt32(bytelength[0] << 24)
                              + Convert.ToUInt32(bytelength[1] << 16)
                              + Convert.ToUInt32(bytelength[2] << 8)
                              + Convert.ToUInt32(bytelength[3] << 0);

          Byte[] XMLfile = new Byte[XMLFilelength];

          // Read the Bytes of the XML file from bufRecv
          for (int i = 0; i < XMLfile.Length; i++)
          {
            XMLfile[i] = bufRecv[i + 7];
          }

          ByteArrayToFile(path + "\\File.xml", XMLfile);
        }
      }
      return false;
    }
    //@@@STOP_READXMLFILE@@@


    public bool ByteArrayToFile(string filename, Byte[] ByteArray)
    {
      // Open file for reading
      FileStream filestream = new FileStream(filename, FileMode.Create, FileAccess.Write);

      // Writes a block of bytes to this stream using data from a byte array
      filestream.Write(ByteArray, 0, ByteArray.Length);

      // Close file stream
      filestream.Close();
      return true;
    }

  }
}
